SystemOrganization addCategory: #reunidosTADP!
SystemOrganization addCategory: #'reunidosTADP-Tests'!

Trait named: #CosteablePorHora
	uses: {}
	category: 'reunidosTADP'!

!CosteablePorHora methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 16:29'!
costoPara: unaReunion
	"calcula el costo para una reunion en base de la duracion de la reunion y el costo por hora"

	^ unaReunion duracion * self costoPorHora! !

!CosteablePorHora methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/18/2012 12:04'!
costoPorHora 
"requerido"! !

Trait named: #Disponible
	uses: {}
	category: 'reunidosTADP'!

!Disponible commentStamp: 'Paul 4/17/2012 16:34' prior: 0!
Trait que se encarga implementa eel metodo disponibleEn: unDia por: cantHoras.

Class Instance Variables:
	name	<Object>
	environment	<SmalltalkImage | (SystemDictionary of: ProtoObject)>
	classTrait	<ClassTrait>
	category	<ProtoObject>!

!Disponible methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 15:53'!
disponibleEn: unDia por: cantHoras
	"responde si esta disponible en cierto dia por una cantidad de horas continuas"

	| compromisos |
	compromisos := self compromisos.	
		
	"No esta implementado!!
	Tendria que pedir los compromisos para unDia y ver si tiene cantHoras cintinuas entre los compromisos"
	^ false! !

Trait named: #Horario
	uses: {}
	category: 'reunidosTADP'!

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:02'!
horariosDisponibles
  | unosRangos rangoLibreUno rangoLibreDos |

unosRangos := Set new.
rangoLibreUno:= Rango rangoUniversal..

self horariosOcupados do:
		[ :rangoOcupado |
			rangoLibreDos := rangoLibreUno substract: rangoOcupado.
			unosRangos add: rangoLibreUno.
			rangoLibreUno := rangoLibreDos. ].
		unosRangos add: rangoLibreDos.
^ unosRangos . ! !

!Horario methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:01'!
horariosOcupados
 "forma parte del contrato de uso del Trait, es un accesor de las instancias de los objetos que usan Horario"! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:03'!
ocupateDurante: unRango
	self horariosOcupados add: unRango.! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:03'!
tenesDisponible: unRango

	^self horariosOcupados allSatisfy: [:rango | (rango overlaps: unRango) not]! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 13:16'!
tenesDuracionDisponible: unaDuracion

^ self horariosDisponibles anySatisfy:  [:unRango | unRango size >= unaDuracion] .! !

TestCase subclass: #TestCriterioMultiple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/19/2012 13:30'!
setUp
|association1 association2|
persona:= Persona nuevaAsignadaA: 'ace' conRol: 'Developer'  enUnEdificio:  'Alem'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol: 'Designer'  enUnEdificio: 'Catalinas'.
persona3:= Persona nuevaAsignadaA: 'notes' conRol:'PM'  enUnEdificio: 'Martinez'.
criterio:= CriterioMultiple new criterios: Dictionary new; personasConvocables: Set new.
"association1:= Association key: 'rol' value: 'Developer'.
association2:= Association key: 'proyecto' value:'ace'. 
criterio criterios add: association1.
criterio criterios add: association2."
criterio criterios at: 'rol' put: 'Developer'; at: 'proyecto' put: 'ace'.
criterio personasConvocables add: persona; add: persona2; add: persona3.! !

!TestCriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 09:55'!
testPersonaCumpleTodosLosCriterios

criterio filtra: criterio personasConvocables .
"self assert: persona proyecto equals: (criterio criterios at: 'proyecto').
self assert: persona rol equals: (criterio criterios at: 'rol')."

self assert: (criterio personasConvocables includes: persona)! !

TestCase subclass: #TestCriterioSimple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioSimple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/19/2012 13:24'!
setUp

persona:= Persona nuevaAsignadaA: 'ace' conRol: 'Developer' enUnEdificio:'huergo2'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio:'Alem'.
persona3:=  Persona nuevaAsignadaA: 'notes' conRol:'Developer'  enUnEdificio: 'Martinez'. 
criterio:= CriterioUnico new condicion: 'proyecto'; parametro: 'ace'; personasConvocables: Set new.
criterio personasConvocables add: persona; add: persona2 ; add:persona3.! !

!TestCriterioSimple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/19/2012 13:25'!
testPersonaCumpleCriterio
 
criterio filtra: criterio personasConvocables.
self assert: (criterio personasConvocables includes: persona).
self assert: persona proyecto equals: criterio parametro.! !

TestCase subclass: #TestHorarioDisponible
	instanceVariableNames: 'persona horarioOcupado rangoUno rangoDos coleccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestHorarioDisponible methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:02'!
setUp 
|inicioRango1 finRango1 inicioRango2 finRango2 rangoCuatro rangoTres |

inicioRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 19  minute: 15.
finRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 22  minute: 15.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

persona:= Persona new.
persona horariosOcupados add: rangoUno.

inicioRango2 := DateAndTime today. 
finRango2 := DateAndTime tomorrow.

rangoDos:= Rango new.
rangoDos start: inicioRango2; end: finRango2.
 
rangoTres:= Rango new.

rangoTres start: DateAndTime today; end: rangoUno start.

rangoCuatro:= rangoUno startingOn: rangoUno end.

coleccion := Set with: rangoTres with: rangoCuatro.! !

!TestHorarioDisponible methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:22'!
testPersonaHorariosDisponiblesRango

| disponibles bol |
disponibles := persona horariosDisponibles.
"verifica que todos los elementos de los horariosDisponibles esten contenidos en la coleccion que viene del #setUp y viceversa"
self assert: (
	disponibles anySatisfy: [:rangoDisponible | 
		coleccion anySatisfy: [:rangoPrueba |
			rangoPrueba equals: rangoDisponible ]
		]
	) .
self assert: (
	coleccion anySatisfy: [:rangoPrueba | 
		disponibles anySatisfy: [:rangoDisponible |
			rangoPrueba equals: rangoDisponible ]
		]
	) .! !

!TestHorarioDisponible methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 13:12'!
testPersonaTenesDisponibleRango

self assert: (persona tenesDisponible: rangoDos).! !

!TestHorarioDisponible methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:22'!
testPersonaTenesDuracionDisponible

self assert: (persona tenesDuracionDisponible: rangoUno size).
self assert: (persona tenesDuracionDisponible: rangoDos size).! !

!TestHorarioDisponible methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:25'!
testPersonaTenesDuracionDisponibleFalse

"si tiene al menos un horarioOcupado, la unica duracion que no tiene disponible es aquella que abarca desde hoy hasta el dia final"

self assert: (persona tenesDuracionDisponible: (Rango rangoUniversal) size) not.! !

TestCase subclass: #TestRequerimiento
	instanceVariableNames: 'criterio1 unRequerimiento criterio2 persona1 persona2 persona3 set1 set2 set3 persona4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

!TestRequerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:58'!
setUp

criterio1:= CriterioUnico nuevoConCondicion: 'rol' yParametro: 'PM'.
criterio2:= CriterioMultiple nuevoConCondiciones: (#('rol' 'proyecto' 'nombre')) parametros: (#('Developer' 'ace' 'Clari')).
persona1:= Persona nuevaAsignadaA: 'ace' conRol:'Developer'  enUnEdificio: 'Catalinas'. 
persona1 nombre: 'Clari'.
persona2:= Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'. 
persona3:= Persona nuevaAsignadaA: 'costSuite' conRol: 'DBA' enUnEdificio: 'Alem'.
persona4:= Persona nuevaAsignadaA: 'estimatedCost' conRol: 'DBA' enUnEdificio: 'Martinez'. 
unRequerimiento:= Requerimiento new requerimientosDeTurno:  (Set with: criterio1 with: criterio2).
unRequerimiento personas: Set new.

set1:= Set with: persona1 with: persona2.
set2:= Set with: persona1 with: persona2 with: persona3.
set3:= Set with: persona3 with: persona4.! !

!TestRequerimiento methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:29'!
testPersonasCumplenRequerimiento

"va a seguir fallando hast que se inicialize la reunion, ahora dice que en el metodo posiblesAsistentesConDisponibilidadHoraria nil esta recibiendo el mje duracion."
unRequerimiento personas: set1.

unRequerimiento seleccionarAsistentes 
.
self assert: (unRequerimiento convocados includesAllOf: set1) description: 'Existen personas que satisfacen el requerimiento'.

! !

!TestRequerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:00'!
testPersonasNoCumplenRequerimiento

unRequerimiento personas: set3.

unRequerimiento seleccionarAsistentes.

self deny: (unRequerimiento convocados includesAllOf: set3) description: 'No hay ninguna persona que cumpla el requerimiento'.


! !

Object subclass: #Catering
	uses: Horario + CosteablePorHora
	instanceVariableNames: 'horariosOcupados costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Catering class
	uses: Horario classTrait + CosteablePorHora classTrait
	instanceVariableNames: ''!

!Catering methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 12:06'!
costoPorHora 
^costo! !

!Catering methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:59'!
horariosOcupados
	^horariosOcupados ! !

!Catering methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 12:05'!
initialize 
horarioOcupado := Set new.! !

Object subclass: #CriterioMultiple
	instanceVariableNames: 'criterios personasConvocables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioMultiple class methodsFor: 'instance creation' stamp: 'ClaraAllende 4/20/2012 09:08'!
nuevoConCondiciones: anArray parametros: anArray2 
"quera evitar fijarme en dos colecciones al mismo tiempo pero al final lo tuve que hacer para asignar el diccionario... Pero bueno, si le paso arrays es ms cmodo para usarlo en el workspace y en los tests"
|nuevoReq|
	nuevoReq:= self new criterios: Dictionary new; personasConvocables: Set new.
	anArray do: [:elem | nuevoReq criterios at: elem put: (anArray2 at:  (anArray indexOf: elem))].
	^nuevoReq
	! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:11'!
criterios
^criterios! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 13:05'!
criterios: unDiccionarioDeSymbolsyParametros
criterios:= unDiccionarioDeSymbolsyParametros ! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:42'!
filtra: unaColeccionDePersonas
self personasConvocables: (unaColeccionDePersonas select: [:candidato | self criterios keys allSatisfy: [:c| (c asSymbol value: candidato)= (criterios at: c).]])! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 09:21'!
initialize
self personasConvocables: Set new.! !

!CriterioMultiple methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:29'!
personasConvocables
	^ personasConvocables! !

!CriterioMultiple methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:29'!
personasConvocables: anObject
	personasConvocables := anObject! !

Object subclass: #CriterioUnico
	instanceVariableNames: 'condicion parametro personasConvocables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioUnico class methodsFor: 'instance creation' stamp: 'ClaraAllende 4/19/2012 20:55'!
nuevoConCondicion: aByteString yParametro: aByteString2 
	^self new condicion: aByteString; parametro: aByteString2; personasConvocables: Set new.! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 16:18'!
condicion
^condicion! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 08:48'!
condicion: unString
"es un String que yo despus voy a manejar como symbol"
condicion:= unString! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/19/2012 21:19'!
filtra: unaColeccionDePersonas
personasConvocables:= unaColeccionDePersonas select: [:candidato | (self condicion asSymbol value: candidato) == self parametro  ]
! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 12:54'!
parametro
^parametro
! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 12:54'!
parametro: unParametro
parametro:= unParametro
! !

!CriterioUnico methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:12'!
personasConvocables
	^ personasConvocables! !

!CriterioUnico methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:12'!
personasConvocables: anObject
	personasConvocables := anObject! !

Object subclass: #Empresa
	instanceVariableNames: 'personas notebooks salas proyectores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Empresa commentStamp: 'ClaraAllende 4/20/2012 12:04' prior: 0!
Empresa representa al objeto que conoce a todas las personas y recursos que se van a chequear para decidir si se puede realizar una reunin o no.

Instance Variables:
	personas	<ProtoObject | PseudoContext>
	notebooks	<ProtoObject | PseudoContext>
	salas	<ProtoObject | PseudoContext>
	proyectores	<ProtoObject | PseudoContext>!

!Empresa class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:02'!
nuevaConPersonas: unasPersonas proyectores: unosProyectores notebooks: unasNotebooks salas: unasSalas

^self new personas: unasPersonas; proyectores: unosProyectores; notebooks: unasNotebooks; salas: unasSalas.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
notebooks
^notebooks! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
notebooks: unaColeccionDeNotebooks
notebooks:= unaColeccionDeNotebooks ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
personas
^personas! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:03'!
personas: unaColeccionDePersonas
personas:= unaColeccionDePersonas ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
proyectores
^proyectores! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
proyectores: unaColeccionDeProyectores
proyectores:= unaColeccionDeProyectores! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
salas
^salas! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
salas: unaColeccionDeSalas
salas:= unaColeccionDeSalas! !

Object subclass: #Notebook
	uses: Horario
	instanceVariableNames: 'horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Notebook class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Notebook methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 14:59'!
horariosOcupados 
	^horariosOcupados ! !

!Notebook methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Persona
	uses: Horario + Disponible + CosteablePorHora @ {#costoPara:->#costoGeneralPara:}
	instanceVariableNames: 'proyecto rol sector edificio nombre compromisos costoPorHora horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Persona commentStamp: 'Paul 4/17/2012 16:37' prior: 0!
Representa a una Persona que puede ser Convocante o Aisistente de una Reunion. 
Como usa trait Disponible tiene que implementar mensaje "compromisos".
Como usa trait CosteablePorHora tiene que implementar mensaje "costoPorHora".
Implementa interfaz Recurso, por eso tiene que sorbreescribir los mentodos:
- disponibleEn: unDia por: horas
- costoPara: unaReunion

Instance Variables:
	proyecto	<ProtoObject | PseudoContext>
	rol	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	edificio	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>
	compromisos	<ProtoObject | PseudoContext>!

Persona class
	uses: Disponible classTrait + CosteablePorHora classTrait + Horario classTrait
	instanceVariableNames: ''!

!Persona class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 15:35'!
nuevaAsignadaA: unProyecto conRol: unRol enUnEdificio: unEdificio
^self new proyecto: unProyecto; rol: unRol; edificio: unEdificio.! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos
	^ compromisos! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos: anObject
	compromisos := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 11:57'!
costoPara: unaReunion
	"calcula el costo para una reunion solo si el convocante es de otro proyecto"

	(unaReunion host proyecto equals: self proyecto)
		ifTrue: [ ^ 0 ]
		ifFalse: [ ^ self costoGeneralPara: unaReunion ]! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora
	^ costoPorHora! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora: anObject
	costoPorHora := anObject! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
edificio
	^ edificio! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
edificio: unEdificio
edificio:= unEdificio! !

!Persona methodsFor: 'manejoDeHoras' stamp: 'LucasGiudice 4/20/2012 15:00'!
horariosOcupados 
^horariosOcupados ! !

!Persona methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:17'!
initialize 
 horarioOcupado := Set new.! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:30'!
nombre
^nombre! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:22'!
nombre: unNombre
nombre:= unNombre! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
proyecto
	^ proyecto! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
proyecto: unProyecto
proyecto:= unProyecto! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
rol: unRol
rol:= unRol! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector: anObject
	sector := anObject! !

Object subclass: #Proyector
	uses: Horario
	instanceVariableNames: 'horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Proyector class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Proyector methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:00'!
horariosOcupados 
	^horariosOcupados ! !

!Proyector methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Requerimiento
	instanceVariableNames: 'rol proyecto sector nombre requerimientosDeTurno convocados personas reunion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Requerimiento commentStamp: 'ClaraAllende 4/20/2012 12:40' prior: 0!
Esta clase representa los posibles requerimientos para convocar a una persona a una reunin. Un requerimiento conoce a un CriterioUnico o un CriterioMultiple, y ellos son los encargados de filtrar las personas y recursos convocables/usables para una reunin. 
Los recursos son opcionales, de modo que si para una reunin son necesarios ciertos recursos, se va a tener que mandar el mensaje #seleccionarRecursosNecesariosDe:  cantidad:  al requerimiento correspondiente a dicha reunin (no voy a crear requeriemientos con recursos por default, porque si tuviera colecciones vacas debera chequear todo el tiempo si tienen elementos o no.)

Instance Variables:
	rol	<ProtoObject | PseudoContext>
	proyecto	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>!

!Requerimiento class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:38'!
nuevoConReqs: unosReqs
^self new requerimientosDeTurno: unosReqs.! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/19/2012 20:49'!
convocados
	^ convocados! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/19/2012 20:49'!
convocados: anObject
	convocados := anObject! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:10'!
filtrarPor: unaColeccinDeCriterios

 unaColeccinDeCriterios do:  [:criterio | criterio filtra: self personas].
! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:53'!
personas
	^ personas! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:54'!
personas: unasPersonas
	personas:= unasPersonas! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:03'!
posiblesAsistentes
^self requerimientosDeTurno inject: Set new into: [:accum : req | accum union: req personasConvocables]! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:47'!
posiblesAsistentesConDisponibilidadHoraria 
^self posiblesAsistentes select: [:p | p tenesDuracionDisponible: self reunion duracion]! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno 
^requerimientosDeTurno! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno: unosReqs
requerimientosDeTurno:= unosReqs.! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:22'!
reunion
^reunion! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:25'!
reunion: unaReunion
reunion:= unaReunion! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:46'!
seleccionarAsistentes

self filtrarPor: self requerimientosDeTurno.
self convocados: self posiblesAsistentesConDisponibilidadHoraria. ! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:33'!
seleccionarRecursosNecesariosDe: unaDeLasColeccionesDeRecursos cantidad: unaCantidad
"De nuevo,voy a manejar strings convirtiendolos a symbols para saber cual coleccin de recursos tengo que filtrar. Es una manera bastante bastante fea de manejarlos, de hecho, me gustara tratarlos polimrficamente, pero bueh"

"Es para charlar si quieren pasarle ms de un recurso o mandar tres veces este mensaje. Esa segunda opcin complejizara un poco el cdigo"
|coleccionDeDisponibles|

coleccionDeDisponibles:= (self reunion empresa perform: (unaDeLasColeccionesDeRecursos asSymbol)) select:[:elem | elem tenesDuracionDisponible: self reunion duracion.].

"Devuelvo los primeros objetos designados por unaCantidad, porque me da lo mismo cualquiera. Adems #first: lanza una excepcin si no pudo encontrar la cantidad de elementos necesarios"
^coleccionDeDisponibles first: unaCantidad.! !

Object subclass: #Reunion
	instanceVariableNames: 'host asistentes recursos edificio duracion requerimiento proyecto horarioOcupado empresa recursosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Reunion class
	instanceVariableNames: 'duracion'!

Reunion class
	instanceVariableNames: 'duracion'!

!Reunion class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:42'!
nuevaConRequerimiento: unRequerimiento convocadaPor: unHost duracion:  unaDuracion empresa: unaEmpresa
^self new host: unHost; requerimiento: unRequerimiento; duracion: unaDuracion; empresa: unaEmpresa.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:31'!
asistentes
^asistentes! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:31'!
asistentes: unaColeccionDeAsistentes
asistentes:= unaColeccionDeAsistentes! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:32'!
convocarAsistentes
	self asistentes: self requerimiento seleccionarAsistentes! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:46'!
duracion
^duracion! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/20/2012 12:58'!
duracion: unaDuracion
duracion:= unaDuracion 

"tiene que ser de tipo Duration "! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:29'!
empresa
^empresa! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:29'!
empresa: unaEmpresa
empresa:= unaEmpresa! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/18/2012 10:26'!
horarioOcupado 
	^horarioOcupado ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
host
^host! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:52'!
host: elHost
host:= elHost! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:52'!
initialize 
      self requerimiento reunion: self.
	self recursosOcupados: Set new.
	horarioOcupado := Set new.
	
	! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:45'!
necesitaRecurso: unRecurso cantidad: unaCantidad
"con la salvedad de que unRecurso es en realidad en plural, i.e, si necesito un proyector, en el parmetro unRecurso debera pasarse el string 'proyectores'. Est acoplado con como manejo los strings para convertirlos en symbols para filtrar las distintas colecciones, pero no se me ocurri una manera menos fea de hacerlo :("

^self requerimiento seleccionarRecursosNecesariosDe: unRecurso cantidad: unaCantidad! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:27'!
personas
^self empresa personas! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 13:37'!
proyecto
^self host proyecto.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:51'!
recursosOcupados
^recursosOcupados ! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:51'!
recursosOcupados: unosRecursos
recursosOcupados:= unosRecursos ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
requerimiento
^requerimiento! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/12/2012 12:55'!
requerimiento: unRequerimiento
requerimiento:= unRequerimiento! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:51'!
reservarRecurso: unRecurso cantidad: unaCantidad
"con la salvedad de que unRecurso es en realidad en plural, i.e, si necesito un proyector, en el parmetro unRecurso debera pasarse el string 'proyectores'. Est acoplado con como manejo los strings para convertirlos en symbols para filtrar las distintas colecciones, pero no se me ocurri una manera menos fea de hacerlo :("

|recursoReservado|

recursoReservado:= self requerimiento seleccionarRecursosNecesariosDe: unRecurso cantidad: unaCantidad.

self recursosOcupados inject: recursoReservado into: [:accum :r | accum union: r].! !

Object subclass: #Sala
	uses: Horario
	instanceVariableNames: 'horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Sala class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Sala methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:01'!
horariosOcupados 
	^horariosOcupados! !

!Sala methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Transporte
	uses: Horario + CosteablePorHora
	instanceVariableNames: 'horariosOcupados costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Transporte class
	uses: Horario classTrait + CosteablePorHora classTrait
	instanceVariableNames: ''!

!Transporte methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/18/2012 12:09'!
costoPorHora 
	^costo! !

!Transporte methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:02'!
horariosOcupados 
	^horariosOcupados ! !

!Transporte methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !
